//---- input parameters
extern double    Lot1=0.1;
extern double    Lot2=0.1;
extern double    Lot3=0.1;
extern string    Sym1="EURUSD";
extern string    Sym2="GBPUSD";
extern string    Sym3="EURJPY";
extern double    Commission1=0.0;
extern double    Commission2=0.0;
extern double    Commission3=0.0;
extern double    Profit=20;
extern double    slippage=2.0;
double Ilo1=0, Ilo2=0, Ilo3=0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init(){
//---- 

//init global variables

if (!GlobalVariableCheck("_CanClose")) {

GlobalVariableSet("_CanClose",0);

}      



//----
   return(0);
  }

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+


int deinit(){
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start(){
Ilo1=Lot1; Ilo2=Lot2; Ilo3=Lot3;


//---- 
double Commissions=0;


Comment("Balance=",AccountBalance(),"\n",Sym1," Lot=",Ilo1,"\n",Sym2," Lot=",Ilo2,"\n",Sym3," Lot=",Ilo3,"\n","\nFloating profit=",CalcProfit()," Expected profit=",Profit);

//---Check for profit

Commissions=Commission1*Ilo1+Commission2*Ilo2 + Commission3*Ilo3;

if ( (CalcProfit()-Commissions) >= (Profit) ) {

GlobalVariableSet("_CanClose",1);

CloseAll();

}    


//----
   return(0);
  }


//+==============================================Profit Calculation ===================================+


double CalcProfit() {

//+============Calculating profit for opened positions for specified trades

int cnt;

double _Profit;

_Profit=0;   

for(cnt=0; cnt<OrdersTotal(); cnt++) {     

   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

	if ((OrderSymbol()==Sym1 || OrderSymbol()==Sym2 || OrderSymbol()==Sym3) && (OrderLots()==Ilo1 || OrderLots()==Ilo2|| OrderLots()==Ilo3)) {

   _Profit=_Profit+OrderProfit(); 

   }   
   
  }
   
   return(_Profit);
}


//+------------------------------------------------------------------+

//+=================================================CLOSE SPECIFIED ORDERS=============================+


void CloseAll(){

int _total=OrdersTotal(); //------------- number of orders  

int _ordertype; //------------------------ order type   

if (_total==0) {return;}

int _ticket; //------------------------ ticket number

double _priceClose; //------------------------- price to close orders;

//=============================================Closing specified positions=========

if (GlobalVariableGet("_CanClose")==1) { 

for(int _i=_total-1;_i>=0;_i--)   { 

    
      if (OrderSelect(_i,SELECT_BY_POS)) { 
    
         _ordertype=OrderType();

         _ticket=OrderTicket();

	            if ((OrderSymbol()==Sym1 || OrderSymbol()==Sym2 || OrderSymbol()==Sym3) && (OrderLots()==Ilo1 || OrderLots()==Ilo2|| OrderLots()==Ilo3)) { 


                                       //-----------------------Closing Order     
                        
                                 switch(_ordertype)
            {
            case 0:
               // close buy                
               _priceClose=MarketInfo(OrderSymbol(),MODE_BID);
               Print("Close on ",_i," position order with ticket ",_ticket);
               OrderClose(_ticket,OrderLots(),_priceClose,slippage,Red);
               break;
            case 1:
               // close sell
               _priceClose=MarketInfo(OrderSymbol(),MODE_ASK);
               Print("Close on ",_i," position order with ticket ",_ticket);
               OrderClose(_ticket,OrderLots(),_priceClose,slippage,Red);
               break;
            
            }    


           } 
            

       }

    } 

 } 

return; 
}